#define ORG .org
#define END .end
#define EQU .equ
#define DB  .db
#define DW  .dw
#define DS  .ds

#define RK86
#define RK86_WW55
;#define FAT12_ON
#define FAT16_ON

;#define STD
;#define MX2

#ifdef MX2  ; MX - SD_MX2
GETC  EQU 0f803H
PUTC  EQU 0f809H
PRINT EQU 0f818H
SD_DATA_PORT EQU 0fff4H
SD_CONF_PORT EQU SD_DATA_PORT+1 ;0fff5H
START_ADDR   EQU 0D400H

CWD EQU 0F000H
FATSEC  EQU 0F100H
BUF     EQU 0E000h
BUFDIR  EQU 0E200h
#endif

#ifdef STD  ; STD - SD_MX2
GETC  EQU 0C803H
PUTC  EQU 0C809H
PRINT EQU 0C818H
SD_DATA_PORT EQU 0f000H
SD_CONF_PORT EQU SD_DATA_PORT+1 ;0f001H
START_ADDR   EQU 0D000H

CWD EQU 0E400H
FATSEC  EQU 0E500H
BUF     EQU 0E000h
BUFDIR  EQU 0E200h
#endif

#ifdef RK86
GETC  EQU 0F803H
PUTC  EQU 0F809H
PRINT EQU 0F818H
PRHEX EQU 0F815H

SD_DATA_PORT EQU 0d000H
SD_CONF_PORT EQU SD_DATA_PORT+1 ;0d001H

SD_DATA_PORT_WW55 EQU 0a000H

#define SD_ROM
#ifdef SD_ROM
START_ADDR   EQU 06000H
#else
START_ADDR   EQU 0f000H
#endif

BUF     EQU 06800h
BUFDIR  EQU BUF+0200h
CWD     EQU BUF+0400H
FATSEC  EQU BUF+0500H
#endif

ROOTSEC EQU FATSEC+4
DATASEC EQU ROOTSEC+4
ROOTLEN EQU DATASEC+4
ROOTLNS EQU ROOTLEN+2
SECINBL EQU ROOTLNS+2
FAT_NXT EQU SECINBL+1
BUFSEC  EQU FAT_NXT+3

BLKLEN  EQU BUFSEC+4
BLKSEC  EQU BLKLEN+1
BNEXT   EQU BLKSEC+4
FBPOS   EQU BNEXT+4
FBLEN   EQU FBPOS+2

DIRREC  EQU FBLEN+2
CWDBLK  EQU DIRREC+1

LINEBUF EQU CWDBLK+4
